library EnviaSMS;
{*************************************************************************
  Escopo padro para envio de SMSs

  Autor: George De Luca
  Data: 25-02-2011
*************************************************************************}

uses
  SysUtils,
  Classes,
  uSMSFacil in 'uSMSFacil.pas';  // .pas com as caractersticas pelo envio com o
                                 // SMS Fcil

{$R *.res}


Function SendSMS(ATel,AMens : String; var ARetorno: String) : Boolean;export;stdcall;
// ***Parametros de Input
// ATel -> nmero do telefone do destinatrio
// AMens -> texto da mensagem a ser enviada
//
// ***Parametro de Output
// ARetorno -> mensagem de retorno da funo
// Result -> true se enviar com sucesso ou false se ocorrer erro no envio
Var
  rSMS : regSMS; // record declarado no uSMSFacil.pas
Begin
  Result := True;
  // mensagem paro
  Try
    If not rSMS.setTelefone(ATel,ARetorno) Then  // seto o nmero do telefone
    Begin
      // caso o nmero do telefone esteja invlido, retorno com o erro
      Result := False;
    End
    Else if not rSMS.setMensagem(AMens,ARetorno) Then // seto a mensagem de texto
    Begin
      // caso a mensagem seja extensa, retorno como erro
      Result := False;
    End
    Else
    Begin
      ARetorno := 'Mensagem enviada com sucesso!';
      // se estiver tudo ok envio o SMS
      ARetorno := rSMS.EnviaSMS;
      Result   := not rSMS.ComErro;  // retorna true ou false se estiver ok ou com erro
    End;
  Except
    On e : Exception Do
    Begin
      Result := False;
      ARetorno := 'EnviaSMS.dll erro: '+e.Message;
    End;
  End;
End;

exports SendSMS index 1;

begin
end.

