unit uLog;

interface

Uses
 DB, Classes, Sysutils,SqlExpr, Forms, Dialogs;

  Type
    TLog = Class(TPersistent)
    Private
      FlstLog   : TStringList;
      FErrMSN   : String;
      FPastaLog : String;
      Procedure ApagaLogAntigo;
    Public
      Constructor Create; Overload;
      Destructor  Destroy; Override;

      Procedure Aviso(AMensagem : String);
      Procedure Erro(AMensagem : String);

      Procedure AddLinha(ALinha : String);
      Procedure Separador;
      Function  UltimaMsgErro : String;
  End;

implementation

{ TLog }

constructor TLog.Create;
begin
  FPastaLog := ExtractFilePath(Application.ExeName);
  ApagaLogAntigo;
  FlstLog := TStringList.Create;
  FlstLog.Add('Log - EnviaSMS.DLL');
  FlstLog.Add('Data/Hora: ' + FormatDateTime('dd/MM/yyyy hh:mm', now));
  FlstLog.Add('');
end;

destructor TLog.Destroy;
Var
  sArquivo : String;
begin
  FlstLog.Add('');
  FlstLog.Add('Fim da execuo');
  FlstLog.Add('Data/Hora: ' + FormatDateTime('dd/MM/yyyy hh:mm', now));
  // gera o log
  sArquivo := FPastaLog+'LOG-ENVIASMS-'+FormatDateTime('yyyyMMdd-hhmm', now)+'.LOG';
  FlstLog.SaveToFile(sArquivo);
  FreeAndNil(FlstLog);
end;

procedure TLog.Aviso(AMensagem: String);
begin
  FlstLog.Add(Format('Aviso (%s): ',[FormatDateTime('dd-MM-yyyy hh:mm:ss',now)]) + AMensagem);
end;

procedure TLog.Erro(AMensagem: String);
begin
  FlstLog.Add(Format('Erro (%s): ',[FormatDateTime('dd-MM-yyyy hh:mm:ss',now)]) + AMensagem);
end;

procedure TLog.AddLinha(ALinha: String);
// adiciona uma linha ao stringlist
begin
  FlstLog.Add(ALinha);
end;

function TLog.UltimaMsgErro: String;
begin
  Result := FErrMSN;
end;

procedure TLog.Separador;
begin
  AddLinha('==========');
end;

procedure TLog.ApagaLogAntigo;
// apago os arquivos de log com mais de 15 dias
var
  Rec: TSearchRec;
  i: integer;
  dtDataArquivo : TDateTime;
  lista: TStringList;
begin
   lista := TStringList.Create;
   if SysUtils.FindFirst(FPastaLog+'*.log', faDirectory, Rec) = 0 then
   try
     repeat
       dtDataArquivo := Trunc(FileDateToDateTime(FileAge(FPastaLog+rec.Name)));
       // verifico os arquivos com mais de 15 dias
       If (dtDataArquivo >-1) and (dtDataArquivo < Trunc(date-15)) Then
       Begin
         lista.Add(FPastaLog+rec.Name);
       End;
     until SysUtils.FindNext(Rec) <> 0;
   finally
     if lista.count <> 0 then
     begin
       i := 0;
       //deleta os arquivos com mais de 15 dias
       repeat
         DeleteFile(lista.Strings[i]);
         inc(i);
       until i >= lista.Count;
     end;
   end;  // finally
   FreeAndNil(lista);
end;

end.
